/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// ExportType the model 'ExportType'
type ExportType string

// List of ExportType
const (
	EXPORT_TYPE_RAW_DATA ExportType = "raw_data"
)

// All allowed values of ExportType enum
var AllowedExportTypeEnumValues = []ExportType{
	"raw_data",
}

func (v *ExportType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ExportType(value)
	for _, existing := range AllowedExportTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ExportType", value)
}

// NewExportTypeFromValue returns a pointer to a valid ExportType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewExportTypeFromValue(v string) (*ExportType, error) {
	ev := ExportType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ExportType: valid values are %v", v, AllowedExportTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ExportType) IsValid() bool {
	for _, existing := range AllowedExportTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ExportType value
func (v ExportType) Ptr() *ExportType {
	return &v
}

type NullableExportType struct {
	value *ExportType
	isSet bool
}

func (v NullableExportType) Get() *ExportType {
	return v.value
}

func (v *NullableExportType) Set(val *ExportType) {
	v.value = val
	v.isSet = true
}

func (v NullableExportType) IsSet() bool {
	return v.isSet
}

func (v *NullableExportType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExportType(val *ExportType) *NullableExportType {
	return &NullableExportType{value: val, isSet: true}
}

func (v NullableExportType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExportType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

